float Left;
float Top;
float Width;
float Height;


struct Vertex
{
  float4 Position : Position;
  float2 UV : TexCoord0;
};

struct TransformedVertex
{
  float4 Position : Position;
  float2 UV : TexCoord0;
};



void QuadVertexShader(in Vertex input, out TransformedVertex output)
{
  output.Position = input.Position;
  output.UV = input.UV;
}


float4 QuadPixelShader(in TransformedVertex input) : COLOR0
{
  float2 uv = input.UV;

  // get the coordinates relative to the input dimensions
  float x = Width * uv.x;
  float y = Height * uv.y;

  // translate the final coordinates
  return float4(Left + x, y - Top, 1, 1);
}


technique GenerateQuad
{
  pass Pass1
  {
    VertexShader = compile vs_2_0 QuadVertexShader();
    PixelShader = compile ps_2_0 QuadPixelShader();
  }
}


